## rkward 0.7.2

=== CMakeLists.txt ===
PROJECT(rkward)

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12)	# As required by KF5
IF(NOT "${CMAKE_VERSION}" VERSION_LESS 3.3.0)
	CMAKE_POLICY(SET CMP0063 NEW)  # Shut up cmake warning
ENDIF()

IF(NOT CMAKE_VERBOSE_MAKEFILE)
	SET (FORCE_PRETTY_MAKEFILE ON)
ENDIF(NOT CMAKE_VERBOSE_MAKEFILE)

FIND_PACKAGE(ECM 0.0.11 REQUIRED NO_MODULE)

SET(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

INCLUDE(KDEInstallDirs)
INCLUDE(KDECMakeSettings)
INCLUDE(KDECompilerSettings)
INCLUDE(ECMInstallIcons)
INCLUDE(ECMAddAppIcon)
INCLUDE(ECMMarkNonGuiExecutable)
INCLUDE(FeatureSummary)

FIND_PACKAGE(Qt5 5.2 CONFIG REQUIRED COMPONENTS Widgets Core Xml Network Script PrintSupport)
FIND_PACKAGE(KF5 5.2 REQUIRED COMPONENTS CoreAddons DocTools I18n XmlGui TextEditor WidgetsAddons Parts Config Notifications WindowSystem OPTIONAL_COMPONENTS Crash)
IF(NOT NO_QT_WEBENGINE)
	FIND_PACKAGE(Qt5 5.2 OPTIONAL_COMPONENTS WebEngineWidgets)
	IF(NOT Qt5WebEngineWidgets_FOUND OR Qt5WebEngineWidgets_VERSION VERSION_LESS "5.12.0")
		MESSAGE(STATUS "QWebEngine not available (or version < 5.12). Falling back to QtWebKit")
		SET(NO_QT_WEBENGINE 1)
	ENDIF()
ENDIF(NOT NO_QT_WEBENGINE)
IF(NO_QT_WEBENGINE)
	FIND_PACKAGE(KF5 5.2 REQUIRED COMPONENTS WebKit)
	ADD_DEFINITIONS(-DNO_QT_WEBENGINE)  # TODO: rather set it for rkhtmlwindow, only
ELSE(NO_QT_WEBENGINE)
	MESSAGE(STATUS "QtWebEngine will be used for rendering HTML. To use KF5WebKit, instead (if available), pass -DNO_QT_WEBENGINE=1 in your call to cmake.")
ENDIF(NO_QT_WEBENGINE)
FIND_PACKAGE(Gettext REQUIRED)

IF(FORCE_PRETTY_MAKEFILE)
	SET(CMAKE_VERBOSE_MAKEFILE OFF)
ENDIF(FORCE_PRETTY_MAKEFILE)

ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_CAST_TO_ASCII)
ADD_DEFINITIONS(-DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
ADD_DEFINITIONS(-DQT_NO_URL_CAST_FROM_STRING)

#uncomment the line below to save ~250-350kB in object size
#ADD_DEFINITIONS(-DRKWARD_NO_TRACE)

ADD_SUBDIRECTORY(rkward)
ADD_SUBDIRECTORY(i18n)
ADD_SUBDIRECTORY(doc)
ADD_SUBDIRECTORY(tests)
KI18N_INSTALL(po)
KDOCTOOLS_INSTALL(po)

FEATURE_SUMMARY(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== i18n/CMakeLists.txt ===
SET(TRANSLATION_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/po/")
FILE(GLOB _dirs "${TRANSLATION_SRC_DIR}/*")
FOREACH(_dir ${_dirs})
	ADD_SUBDIRECTORY("${_dir}")
ENDFOREACH()

=== rkward/CMakeLists.txt ===
IF(NOT ${PROJECT_NAME} STREQUAL "rkward")
	MESSAGE (FATAL_ERROR "Build triggered from wrong subdirectory. Please point cmake to the parent of this directory, instead.")
ENDIF(NOT ${PROJECT_NAME} STREQUAL "rkward")

INCLUDE(SetVersionNumber.cmake)

IF(APPLE)
	SET(CPACK_BUNDLE_ICON rkward.icns)
	SET(CPACK_BUNDLE_NAME RKWard)
	SET(CPACK_BUNDLE_STARTUP_COMMAND rkward)
ENDIF()

# once tested and working this could become the default on Mac:
OPTION(APPLE_STANDALONE_BUNDLE "Generate a standalone app bundle when building on Mac" OFF)
ADD_FEATURE_INFO("App Bundle" APPLE_STANDALONE_BUNDLE "Generate a standalone app bundle when building on Mac. Do not use for now.")

ADD_SUBDIRECTORY( dataeditor )
ADD_SUBDIRECTORY( settings )
ADD_SUBDIRECTORY( plugin )
ADD_SUBDIRECTORY( agents )
ADD_SUBDIRECTORY( rbackend )
ADD_SUBDIRECTORY( dialogs )
ADD_SUBDIRECTORY( scriptbackends )
ADD_SUBDIRECTORY( misc )
ADD_SUBDIRECTORY( core )
ADD_SUBDIRECTORY( icons )
ADD_SUBDIRECTORY( windows )
ADD_SUBDIRECTORY( syntax )

INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

SET(RKWard_Sources
	rkward.cpp
	main.cpp
	rkglobals.cpp
	robjectviewer.cpp
	rkconsole.cpp
)
QT5_ADD_RESOURCES(RKWard_Sources resources.qrc)

# somehow the detected R paths from FindR.cmake do not get passed down automatically
GET_DIRECTORY_PROPERTY(R_EXECUTABLE DIRECTORY rbackend DEFINITION R_EXECUTABLE)
GET_DIRECTORY_PROPERTY(R_SHAREDLIBDIR DIRECTORY rbackend LINK_DIRECTORIES)
LINK_DIRECTORIES(${R_SHAREDLIBDIR})

IF(APPLE)
    # create the application icon from the available sources. This should work on MS Windows
    # too but I don't want to start modifying things I cannot test.
    FILE(GLOB ICON_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/icons/app-icon/*-apps-rkward.png") 
    # recent ECM versions will prefer the scalable version: prepend it to the icon source list:
    ECM_ADD_APP_ICON(RKWard_Sources ICONS ${CMAKE_CURRENT_SOURCE_DIR}/icons/app-icon/sc-apps-rkward.svgz ${ICON_SRCS})
    ADD_EXECUTABLE(rkward ${RKWard_Sources})
ELSE()
    ADD_CUSTOM_COMMAND (OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/rkward.ico"
			COMMAND cmake -E copy "${CMAKE_CURRENT_SOURCE_DIR}/icons/app-icon/rkward.ico"
			"${CMAKE_CURRENT_BINARY_DIR}/rkward.ico")
    ADD_EXECUTABLE(rkward ${RKWard_Sources} rkward_windows_icon.rc rkward.ico)
ENDIF()

# NOTE: These definitions are needed for the startup procedure (main.cpp), only.
# We should switch with to target_compile_definitions once we require CMAKE 2.6+
ADD_DEFINITIONS(-DR_EXECUTABLE="${R_EXECUTABLE}")
ADD_DEFINITIONS(-DINSTALL_PATH="${CMAKE_INSTALL_PREFIX}")
SET_TARGET_PROPERTIES(rkward PROPERTIES
        MACOSX_BUNDLE_BUNDLE_NAME "RKWard")

IF(APPLE)
	SET(RKWARD_INFOPLIST_TEMPLATE Info.plist.in)
	SET(RKWARD_INFOPLIST_FILE ${CMAKE_SOURCE_DIR}/rkward/Info.plist)
	CONFIGURE_FILE(
		${RKWARD_INFOPLIST_TEMPLATE}
		${RKWARD_INFOPLIST_FILE}
		@ONLY)
ENDIF(APPLE)

TARGET_LINK_LIBRARIES(rkward windows ${RKWARD_ADDLIBS} agents dialogs plugin settings dataeditor core scriptbackends rbackend misc KF5::WindowSystem Qt5::Widgets KF5::XmlGui)
IF(KF5Crash_FOUND)
	TARGET_LINK_LIBRARIES(rkward KF5::Crash)
	SET_SOURCE_FILES_PROPERTIES(main.cpp PROPERTIES COMPILE_DEFINITIONS WITH_KCRASH=1)
ENDIF(KF5Crash_FOUND)

########### install files ###############

INSTALL(DIRECTORY plugins/ pages DESTINATION ${DATA_INSTALL_DIR}/rkward)
INSTALL(FILES resource.ver DESTINATION ${DATA_INSTALL_DIR}/rkward)
IF(NOT WIN32)
	# This is for running directly from the build tree. Not on windows for now (until cmake supports symlinks, there)
	ADD_CUSTOM_TARGET(local_install ALL
		COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall
		COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/pages ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/pages
		COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/plugins ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/plugins
		COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/resource.ver ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/resource.ver
		COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/scriptbackends ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/phpfiles
		COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_BINARY_DIR}/rbackend/rpackages ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/rpackages
	)
ENDIF(NOT WIN32)


IF(APPLE)
    INSTALL(TARGETS rkward DESTINATION ${BUNDLE_INSTALL_DIR})
    if(APPLE_STANDALONE_BUNDLE)
#         INSTALL(FILES ${CMAKE_SOURCE_DIR}/rkward/icons/app-icon/rkward.icns DESTINATION ${BUNDLE_INSTALL_DIR}/${CPACK_BUNDLE_NAME}.app/Contents/Resources)
#         INSTALL(FILES ${RKWARD_INFOPLIST_FILE} DESTINATION ${BUNDLE_INSTALL_DIR}/${CPACK_BUNDLE_NAME}.app/Contents)
    ENDIF()
    # the MacOSX bundle display name property (CFBundleDisplayName) is not currently supported by cmake,
    # so has to be set for all targets in this cmake file
    SET(MACOSX_BUNDLE_DISPLAY_NAME RKWard)
    # We provide our own Info.plist, but for the wrapper only
    set_target_properties(rkward PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${RKWARD_INFOPLIST_FILE})
    set_target_properties(rkward PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.RKWard")
    set_target_properties(rkward PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "RKWard")
    set_target_properties(rkward PROPERTIES MACOSX_BUNDLE_DISPLAY_NAME "RKWard")
    set_target_properties(rkward PROPERTIES MACOSX_BUNDLE_INFO_STRING "Frontend to the R statistics language")
    set_target_properties(rkward PROPERTIES MACOSX_BUNDLE_LONG_VERSION_STRING "RKWard ${RKVERSION_NUMBER}")
    set_target_properties(rkward PROPERTIES MACOSX_BUNDLE_SHORT_VERSION_STRING "${RKVERSION_NUMBER}")
    set_target_properties(rkward PROPERTIES MACOSX_BUNDLE_BUNDLE_VERSION "${RKVERSION_NUMBER}")
    set_target_properties(rkward PROPERTIES MACOSX_BUNDLE_COPYRIGHT "RKWard Team")
ELSE()
    INSTALL(TARGETS rkward DESTINATION ${BIN_INSTALL_DIR})
ENDIF()

INSTALL(FILES org.kde.rkward.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
INSTALL(FILES org.kde.rkward.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
INSTALL(FILES vnd.rkward.r.xml DESTINATION ${XDG_MIME_INSTALL_DIR})
INSTALL(FILES rkward.protocol DESTINATION ${SERVICES_INSTALL_DIR})

INSTALL(FILES RKWardRMd.xml DESTINATION ${DATA_INSTALL_DIR}/ktexteditor_snippets/data)

=== doc/rkward/CMakeLists.txt ===
kdoctools_create_handbook (index.docbook INSTALL_DESTINATION ${HTML_INSTALL_DIR}/en SUBDIR rkward)
kdoctools_create_manpage (man-rkward.1.docbook 1 INSTALL_DESTINATION ${MAN_INSTALL_DIR})

=== rkward/dataeditor/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

SET(dataeditor_STAT_SRCS
   twintable.cpp
   twintablemember.cpp
   rkeditor.cpp
   rkeditordataframe.cpp
   rkvareditmodel.cpp
   rktextmatrix.cpp
   )

ADD_LIBRARY(dataeditor STATIC ${dataeditor_STAT_SRCS})
TARGET_LINK_LIBRARIES(dataeditor Qt5::Widgets KF5::WidgetsAddons KF5::Parts)

=== rkward/dialogs/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}    )

SET(dialogs_STAT_SRCS
   startupdialog.cpp
   rkloadlibsdialog.cpp
   rkreadlinedialog.cpp
   rkimportdialog.cpp
   rkselectlistdialog.cpp
   rkrecoverdialog.cpp
   rkerrordialog.cpp
   rksetupwizard.cpp
   )

ADD_LIBRARY(dialogs STATIC ${dialogs_STAT_SRCS})
TARGET_LINK_LIBRARIES(dialogs Qt5::Widgets KF5::Parts KF5::ConfigWidgets KF5::TextEditor)

=== rkward/misc/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

SET(misc_STAT_SRCS
   rkspinbox.cpp
   getfilenamewidget.cpp
   rkobjectlistview.cpp
   xmlhelper.cpp
   multistringselector.cpp
   rkcommonfunctions.cpp
   rkprogresscontrol.cpp
   rksaveobjectchooser.cpp
   rkdummypart.cpp
   rkjobsequence.cpp
   rkspecialactions.cpp
   rkstandardicons.cpp
   rkstandardactions.cpp
   rkxmlguisyncer.cpp
   rkcommandhistory.cpp
   rktableview.cpp
   celleditor.cpp
   editlabelsdialog.cpp
   editformatdialog.cpp
   rkmessagecatalog.cpp
   rkdbusapi.cpp
   rkfindbar.cpp
   rkdynamicsearchline.cpp
   rkaccordiontable.cpp
   rkxmlguipreviewarea.cpp
   rkdialogbuttonbox.cpp
   )

ADD_LIBRARY(misc STATIC ${misc_STAT_SRCS})
TARGET_LINK_LIBRARIES(misc Qt5::Widgets KF5::WidgetsAddons KF5::KIOWidgets Qt5::Xml KF5::ConfigCore KF5::Parts KF5::WindowSystem KF5::TextEditor)

=== rkward/rbackend/CMakeLists.txt ===
INCLUDE(FindR.cmake)
IF(NOT WIN32)
	# for pthread_at_fork
	FIND_PACKAGE(Threads)
ENDIF(NOT WIN32)

ADD_SUBDIRECTORY( rpackages )
ADD_SUBDIRECTORY( rkwarddevice )

INCLUDE_DIRECTORIES( ${R_INCLUDEDIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} )

SET (
	rbackend_shared_SRCS
	rkrbackendprotocol_shared.cpp
	rdata.cpp
)

SET (
	rbackend_backend_SRCS
	rkrbackend.cpp
	rksignalsupport.cpp
	rkrsupport.cpp
	rkstructuregetter.cpp
	rkrbackendprotocol_backend.cpp
	rkreventloop.cpp
)

SET (
	rbackend_frontend_SRCS
	rkrinterface.cpp
	rcommand.cpp
	rcommandreceiver.cpp
	rcommandstack.cpp
	rkrbackendprotocol_frontend.cpp
	rksessionvars.cpp
)

SET (
	rbackend_FRONTEND_SRCS
	${rbackend_frontend_SRCS}
	${rbackend_shared_SRCS}
	rkfrontendtransmitter.cpp
	rktransmitter.cpp
)
ADD_LIBRARY(rbackend STATIC ${rbackend_FRONTEND_SRCS})
TARGET_LINK_LIBRARIES(rbackend rkgraphicsdevice.frontend Qt5::Widgets KF5::TextEditor KF5::WindowSystem)

SET (
	rbackend_BACKEND_SRCS
	${rbackend_backend_SRCS}
	${rbackend_shared_SRCS}
	rkbackendtransmitter.cpp
	rktransmitter.cpp
)
ADD_DEFINITIONS (-DRKWARD_SPLIT_PROCESS)
ADD_DEFINITIONS (-DRKWARD_BACKEND_PATH="${KDE_INSTALL_FULL_LIBEXECDIR}")
LINK_DIRECTORIES(${R_SHAREDLIBDIR})
ADD_EXECUTABLE(rkward.rbackend ${rbackend_BACKEND_SRCS})
ECM_MARK_NONGUI_EXECUTABLE(rkward.rbackend)
TARGET_LINK_LIBRARIES(rkward.rbackend rkgraphicsdevice.backend ${R_USED_LIBS} ${CMAKE_THREAD_LIBS_INIT} Qt5::Network Qt5::Core KF5::I18n)
IF(APPLE)
    TARGET_LINK_LIBRARIES(rkward.rbackend "-framework CoreFoundation")
ENDIF()

IF(WIN32)
	# on Widows, we install to the rbackend subdirectory, because 1) LIBEXEC_INSTALL_DIR == BIN_INSTALL_DIR and 2) we don't want the backend to pick up
	# all the KDE library versions, first, when loading DLLs
	INSTALL(TARGETS rkward.rbackend DESTINATION ${BIN_INSTALL_DIR}/rbackend)
ELSE(WIN32)
	INSTALL(TARGETS rkward.rbackend DESTINATION ${LIBEXEC_INSTALL_DIR})
ENDIF(WIN32)

=== rkward/scriptbackends/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}    )

SET(scriptbackends_STAT_SRCS
   scriptbackend.cpp
   simplebackend.cpp
   qtscriptbackend.cpp
   qtscripti18n.cpp
   rkcomponentscripting.cpp
   )

ADD_LIBRARY(scriptbackends STATIC ${scriptbackends_STAT_SRCS})
TARGET_LINK_LIBRARIES(scriptbackends Qt5::Script Qt5::Widgets Qt5::Xml KF5::WidgetsAddons KF5::I18n)

INSTALL(FILES common.js rkcomponentscripting.js DESTINATION ${DATA_INSTALL_DIR}/rkward/phpfiles )

=== rkward/settings/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}    )


########### next target ###############

SET(settings_STAT_SRCS
   rksettings.cpp
   rksettingsmodule.cpp
   rksettingsmodulegeneral.cpp
   rksettingsmoduleoutput.cpp
   rksettingsmodulegraphics.cpp
   rksettingsmodulekateplugins.cpp
   rksettingsmoduleplugins.cpp
   rksettingsmoduler.cpp
   rksettingsmodulewatch.cpp
   rksettingsmoduleobjectbrowser.cpp
   rksettingsmoduleconsole.cpp
   rksettingsmodulecommandeditor.cpp
   rksettingsmoduledebug.cpp
   )

IF (WIN32 OR USE_BINARY_PACKAGES)
	SET_PROPERTY (
		SOURCE rksettingsmoduler.cpp
		APPEND
		PROPERTY COMPILE_DEFINITIONS
		USE_BINARY_PACKAGES=1
	)
ENDIF (WIN32 OR USE_BINARY_PACKAGES)

ADD_LIBRARY(settings STATIC ${settings_STAT_SRCS})
TARGET_LINK_LIBRARIES(settings Qt5::Widgets KF5::WidgetsAddons Qt5::Xml KF5::ConfigCore KF5::Parts KF5::TextEditor)

=== rkward/windows/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}  )

########### next target ###############

SET(windows_STAT_SRCS
	rkcommandeditorwindow.cpp
	rkdebugconsole.cpp
	rkcallstackviewer.cpp
	rkhtmlwindow.cpp
	rcontrolwindow.cpp
	detachedwindowcontainer.cpp
	rkmdiwindow.cpp
	rkworkplaceview.cpp
	rkworkplace.cpp
	rkwindowcatcher.cpp
	rkcommandlog.cpp
	rkhelpsearchwindow.cpp
	rktoplevelwindowgui.cpp
	rkfilebrowser.cpp
	rktoolwindowbar.cpp
	rktoolwindowlist.cpp
	robjectbrowser.cpp
	rkdebugmessagewindow.cpp
	katepluginintegration.cpp
	rkcodecompletion.cpp
)

ADD_LIBRARY(windows STATIC ${windows_STAT_SRCS})
IF(NO_QT_WEBENGINE)
TARGET_LINK_LIBRARIES(windows Qt5::Widgets Qt5::Xml Qt5::PrintSupport Qt5::WebKitWidgets KF5::WebKit KF5::TextEditor KF5::Notifications KF5::WindowSystem KF5::KIOFileWidgets)
ELSE(NO_QT_WEBENGINE)
TARGET_LINK_LIBRARIES(windows Qt5::Widgets Qt5::Xml Qt5::PrintSupport Qt5::WebEngineWidgets KF5::TextEditor KF5::Notifications KF5::WindowSystem KF5::KIOFileWidgets)
ENDIF(NO_QT_WEBENGINE)

=== rkward/icons/app-icon/CMakeLists.txt ===
ECM_INSTALL_ICONS(ICONS 16-apps-rkward.png 22-apps-rkward.png 32-apps-rkward.png 48-apps-rkward.png 64-apps-rkward.png 128-apps-rkward.png sc-apps-rkward.svgz DESTINATION ${ICON_INSTALL_DIR})

=== debian/changelog ===
rkward (0.7.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the cmake build flags:
    - pass -DNO_QT_WEBENGINE=1 to keep using KDEWebKit for now
    - drop -DNO_R_XML=1, no more needed now
    - drop -DBUILD_TIMESTAMP, no more used since 0.7.1; because of this, stop
      including /usr/share/dpkg/pkg-info.mk
  * Drop removal of x-test translations, as they are no more shipped.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
  * Update install files.
  * Fix day-of-week for changelog entries 0.6.1-1, 0.6.0-3, 0.5.6-1, 0.5.5-2,
    0.5.0d-3, 0.5.0d-2, 0.5.0c-1, 0.4.8a-2, 0.4.2-1.

 -- Pino Toscano <pino@debian.org>  Fri, 16 Oct 2020 11:25:10 +0200

=== debian/control ===
Source: rkward
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Thomas Friedrichsmeier <thomas.friedrichsmeier@kdemail.net>,
           Dylan Aïssi <daissi@debian.org>
Section: math
Priority: optional
Build-Depends: cmake (>= 2.8.12~),
               extra-cmake-modules,
               gettext,
               pkg-kde-tools,
               debhelper-compat (= 13),
               libkf5config-dev (>= 5.4.0~),
               libkf5coreaddons-dev (>= 5.4.0~),
               libkf5crash-dev (>= 5.4.0~),
               libkf5doctools-dev (>= 5.4.0~),
               libkf5i18n-dev (>= 5.4.0~),
               libkf5notifications-dev (>= 5.4.0~),
               libkf5parts-dev (>= 5.4.0~),
               libkf5texteditor-dev (>= 5.4.0~),
               libkf5xmlgui-dev (>= 5.4.0~),
               libkf5webkit-dev (>= 5.4.0~),
               libkf5widgetsaddons-dev (>= 5.4.0~),
               libkf5windowsystem-dev (>= 5.4.0~),
               libqt5webkit5-dev (>= 5.2.0~),
               qtbase5-dev (>= 5.2.0~),
               qtscript5-dev (>= 5.2.0~),
               r-base-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/rkward
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/rkward.git
Homepage: https://rkward.kde.org
Rules-Requires-Root: no

Package: rkward
Architecture: any
Depends: rkward-data (= ${source:Version}),
         ${misc:Depends},
         ${rvers},
         ${rapivers},
         ${shlibs:Depends}
Recommends: r-base-html
Breaks: rkward-data (<< 0.7.1b-2~)
Replaces: rkward-data (<< 0.7.1b-2~)
Description: KDE frontend to the R statistics language
 RKWard aims to become an easy to use, transparent frontend to R,
 a powerful system for statistical computation and graphics.
 Besides a convenient GUI for the most important statistical functions,
 future versions will also provide seamless integration with an
 office-suite.

Package: rkward-data
Architecture: all
Depends: ${misc:Depends}
Recommends: rkward
Description: KDE frontend to the R statistics language - data files
 RKWard aims to become an easy to use, transparent frontend to R,
 a powerful system for statistical computation and graphics.
 Besides a convenient GUI for the most important statistical functions,
 future versions will also provide seamless integration with an
 office-suite.
 .
 This package provides the architecture independent data files for rkward.

=== debian/rules ===
#!/usr/bin/make -f

# We need to know the R version
RVERS = $(shell dpkg-query -W --showformat='$${Version}' r-base-core)
RAPI = $(shell dpkg-query -W --showformat='$${Provides}' r-base-core | grep -o 'r-api[^, ]*')

# easier typing
DESTDIR = $(CURDIR)/debian/tmp

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure '--buildsystem=kf5' -- \
		-DR_EXECUTABLE=/usr/bin/R/ \
		-DNO_QT_WEBENGINE=1 \
		-DCMAKE_SKIP_RPATH=YES

override_dh_auto_install:
	dh_auto_install

	# remove unneeded R package files
	rm -vf $(DESTDIR)/usr/lib/R/site-library/R.css $(DESTDIR)/usr/lib/R/site-library/rkward/COPYING

override_dh_shlibdeps:
	dh_shlibdeps
	echo "rvers=r-base-core (>= $(RVERS))" >> $(CURDIR)/debian/rkward.substvars ;
	echo "rapivers=$(RAPI)" >> $(CURDIR)/debian/rkward.substvars ;

=== debian/watch ===
version=3
https://download.kde.org/stable/rkward/([\d.]+)/src/rkward-([\d.]+)\.tar\.gz

## rkward 0.7.4

=== debian/changelog ===
rkward (0.7.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update watch file.
  * Update standards version to 4.6.1, no changes needed.
  * Update the build dependencies according to the upstream build system:
    - add qtdeclarative5-dev
    - drop qtscript5-dev

 -- Pino Toscano <pino@debian.org>  Tue, 31 May 2022 08:44:51 +0200

rkward (0.7.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release:
    - builds with newer versions of R (Closes: #1008322)
  * Update watch file format version to 4.
  * Update standards version to 4.6.0, no changes needed.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.10.0
    - bump the Qt5 package to 5.9.0
    - bump the KF5 packages to 5.44.0
    - add libkf5archive-dev
  * debian/upstream/metadata: improve Repository* keys.
  * Do not try to remove R.css, and COPYING from the installed files, as they
    are no nore shipped.
  * Rename docs to rkward.docs to make it clear to which package it refers.
  * Move handling of the r-base-core & r-api substvars directly when calling
    dh_gencontrol, rather than adding them to rkward.substvars; simplify rules
    a bit, and runs the dpkg commands only when & where needed.

 -- Pino Toscano <pino@debian.org>  Sun, 24 Apr 2022 20:04:10 +0200

=== debian/control ===
--- 
+++ 
@@ -4,28 +4,29 @@
            Dylan Aïssi <daissi@debian.org>
 Section: math
 Priority: optional
-Build-Depends: cmake (>= 2.8.12~),
+Build-Depends: cmake (>= 3.10.0~),
                extra-cmake-modules,
                gettext,
                pkg-kde-tools,
                debhelper-compat (= 13),
-               libkf5config-dev (>= 5.4.0~),
-               libkf5coreaddons-dev (>= 5.4.0~),
-               libkf5crash-dev (>= 5.4.0~),
-               libkf5doctools-dev (>= 5.4.0~),
-               libkf5i18n-dev (>= 5.4.0~),
-               libkf5notifications-dev (>= 5.4.0~),
-               libkf5parts-dev (>= 5.4.0~),
-               libkf5texteditor-dev (>= 5.4.0~),
-               libkf5xmlgui-dev (>= 5.4.0~),
-               libkf5webkit-dev (>= 5.4.0~),
-               libkf5widgetsaddons-dev (>= 5.4.0~),
-               libkf5windowsystem-dev (>= 5.4.0~),
-               libqt5webkit5-dev (>= 5.2.0~),
-               qtbase5-dev (>= 5.2.0~),
-               qtscript5-dev (>= 5.2.0~),
+               libkf5archive-dev (>= 5.44.0~),
+               libkf5config-dev (>= 5.44.0~),
+               libkf5coreaddons-dev (>= 5.44.0~),
+               libkf5crash-dev (>= 5.44.0~),
+               libkf5doctools-dev (>= 5.44.0~),
+               libkf5i18n-dev (>= 5.44.0~),
+               libkf5notifications-dev (>= 5.44.0~),
+               libkf5parts-dev (>= 5.44.0~),
+               libkf5texteditor-dev (>= 5.44.0~),
+               libkf5xmlgui-dev (>= 5.44.0~),
+               libkf5webkit-dev (>= 5.44.0~),
+               libkf5widgetsaddons-dev (>= 5.44.0~),
+               libkf5windowsystem-dev (>= 5.44.0~),
+               libqt5webkit5-dev (>= 5.9.0~),
+               qtbase5-dev (>= 5.9.0~),
+               qtdeclarative5-dev (>= 5.9.0~),
                r-base-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/rkward
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/rkward.git
 Homepage: https://rkward.kde.org

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure '--buildsystem=kf5' -- \
		-DR_EXECUTABLE=/usr/bin/R/ \
		-DNO_QT_WEBENGINE=1 \
		-DCMAKE_SKIP_RPATH=YES

override_dh_gencontrol-arch:
	# We need to know the R version
	dh_gencontrol -a -- \
	  -V'rvers=r-base-core (>= $(shell dpkg-query -W --showformat='$${Version}' r-base-core))' \
	  -V'rapivers=$(shell dpkg-query -W --showformat='$${Provides}' r-base-core | grep -o 'r-api[^, ]*')'

## rkward 0.7.5

=== rkward/CMakeLists.txt ===
--- 
+++ 
@@ -26,13 +26,14 @@
 ADD_SUBDIRECTORY( icons )
 ADD_SUBDIRECTORY( windows )
 ADD_SUBDIRECTORY( syntax )
+IF(BUILD_TESTING)
+	ADD_SUBDIRECTORY(autotests)
+ENDIF(BUILD_TESTING)
 
 INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
 
 SET(RKWard_Sources
 	rkward.cpp
-	main.cpp
-	rkglobals.cpp
 	robjectviewer.cpp
 	rkconsole.cpp
 )
@@ -43,23 +44,15 @@
 GET_DIRECTORY_PROPERTY(R_SHAREDLIBDIR DIRECTORY rbackend LINK_DIRECTORIES)
 LINK_DIRECTORIES(${R_SHAREDLIBDIR})
 
-IF(APPLE)
-    # create the application icon from the available sources. This should work on MS Windows
-    # too but I don't want to start modifying things I cannot test.
-    FILE(GLOB ICON_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/icons/app-icon/*-apps-rkward.png") 
-    # recent ECM versions will prefer the scalable version: prepend it to the icon source list:
-    ECM_ADD_APP_ICON(RKWard_Sources ICONS ${CMAKE_CURRENT_SOURCE_DIR}/icons/app-icon/sc-apps-rkward.svgz ${ICON_SRCS})
-    ADD_EXECUTABLE(rkward ${RKWard_Sources})
-ELSE()
-    ADD_CUSTOM_COMMAND (OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/rkward.ico"
-			COMMAND cmake -E copy "${CMAKE_CURRENT_SOURCE_DIR}/icons/app-icon/rkward.ico"
-			"${CMAKE_CURRENT_BINARY_DIR}/rkward.ico")
-    ADD_EXECUTABLE(rkward ${RKWard_Sources} rkward_windows_icon.rc rkward.ico)
-ENDIF()
+FILE(GLOB ICON_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/icons/app-icon/*-apps-rkward.png")
+# recent ECM versions will prefer the scalable version: prepend it to the icon source list (older versions generate a warning on the SVG, but so what):
+ECM_ADD_APP_ICON(RKWard_Sources ICONS ${CMAKE_CURRENT_SOURCE_DIR}/icons/app-icon/sc-apps-rkward.svgz ${ICON_SRCS})
+ADD_LIBRARY(rkward_lib STATIC ${RKWard_Sources}) # For auto-tests: pack everything except main in a dummy library
+TARGET_COMPILE_DEFINITIONS(rkward_lib PUBLIC -DR_EXECUTABLE="${R_EXECUTABLE}")
+ADD_EXECUTABLE(rkward main.cpp)
 
 # NOTE: These definitions are needed for the startup procedure (main.cpp), only.
 # We should switch with to target_compile_definitions once we require CMAKE 2.6+
-ADD_DEFINITIONS(-DR_EXECUTABLE="${R_EXECUTABLE}")
 ADD_DEFINITIONS(-DINSTALL_PATH="${CMAKE_INSTALL_PREFIX}")
 SET_TARGET_PROPERTIES(rkward PROPERTIES
         MACOSX_BUNDLE_BUNDLE_NAME "RKWard")
@@ -73,7 +66,8 @@
 		@ONLY)
 ENDIF(APPLE)
 
-TARGET_LINK_LIBRARIES(rkward windows ${RKWARD_ADDLIBS} agents dialogs plugin settings dataeditor core scriptbackends rbackend misc KF5::WindowSystem Qt5::Widgets KF5::XmlGui)
+TARGET_LINK_LIBRARIES(rkward_lib windows ${RKWARD_ADDLIBS} agents dialogs plugin settings dataeditor core scriptbackends rbackend misc KF5::WindowSystem Qt5::Widgets KF5::XmlGui)
+TARGET_LINK_LIBRARIES(rkward rkward_lib)
 IF(KF5Crash_FOUND)
 	TARGET_LINK_LIBRARIES(rkward KF5::Crash)
 	SET_SOURCE_FILES_PROPERTIES(main.cpp PROPERTIES COMPILE_DEFINITIONS WITH_KCRASH=1)
@@ -83,17 +77,23 @@
 
 INSTALL(DIRECTORY plugins/ pages DESTINATION ${DATA_INSTALL_DIR}/rkward)
 INSTALL(FILES resource.ver DESTINATION ${DATA_INSTALL_DIR}/rkward)
-IF(NOT WIN32)
-	# This is for running directly from the build tree. Not on windows for now (until cmake supports symlinks, there)
-	ADD_CUSTOM_TARGET(local_install ALL
-		COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall
-		COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/pages ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/pages
-		COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/plugins ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/plugins
-		COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/resource.ver ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/resource.ver
-		COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/scriptbackends ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/phpfiles
-		COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_BINARY_DIR}/rbackend/rpackages ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/rpackages
-	)
-ENDIF(NOT WIN32)
+# This is for running directly from the build tree.
+EXECUTE_PROCESS(
+	COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall
+	COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/rbackend/rpackages # populated later during the build
+)
+EXECUTE_PROCESS(
+	COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/icons ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/icons
+	COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/pages ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/pages
+	COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/plugins ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/plugins
+	COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/resource.ver ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/resource.ver
+	COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/scriptbackends ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/phpfiles
+	COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_BINARY_DIR}/rbackend/rpackages ${CMAKE_CURRENT_BINARY_DIR}/rkwardinstall/rpackages
+	RESULT_VARIABLE SYMLINKS_FAILED
+)
+IF(SYMLINKS_FAILED)
+	MESSAGE(WARNING "Failed to create symbolic links inside build tree. This is ok in a regular installation, but running from the build tree will fail (i.e. tests will fail).")
+ENDIF(SYMLINKS_FAILED)
 
 
 IF(APPLE)
@@ -121,7 +121,18 @@
 
 INSTALL(FILES org.kde.rkward.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
 INSTALL(FILES org.kde.rkward.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
+INSTALL(FILES rkward.protocol DESTINATION ${SERVICES_INSTALL_DIR})
 INSTALL(FILES vnd.rkward.r.xml DESTINATION ${XDG_MIME_INSTALL_DIR})
-INSTALL(FILES rkward.protocol DESTINATION ${SERVICES_INSTALL_DIR})
+INSTALL(FILES vnd.kde.rkward-output.xml DESTINATION ${XDG_MIME_INSTALL_DIR})
+INSTALL(FILES vnd.kde.rmarkdown.xml DESTINATION ${XDG_MIME_INSTALL_DIR})
+FIND_PACKAGE(SharedMimeInfo)
+IF(SharedMimeInfo_FOUND)
+	UPDATE_XDG_MIMETYPES(${XDG_MIME_INSTALL_DIR})
+ENDIF(SharedMimeInfo_FOUND)
 
 INSTALL(FILES RKWardRMd.xml DESTINATION ${DATA_INSTALL_DIR}/ktexteditor_snippets/data)
+INSTALL(FILES RKWardLaTeX.xml DESTINATION ${DATA_INSTALL_DIR}/ktexteditor_snippets/data)
+INSTALL(FILES RKWardR.xml DESTINATION ${DATA_INSTALL_DIR}/ktexteditor_snippets/data)
+INSTALL(FILES RKWardroxygen2.xml DESTINATION ${DATA_INSTALL_DIR}/ktexteditor_snippets/data)
+INSTALL(FILES RKWardutils.xml DESTINATION ${DATA_INSTALL_DIR}/ktexteditor_snippets/data)
+INSTALL(FILES RKWardpapaja.xml DESTINATION ${DATA_INSTALL_DIR}/ktexteditor_snippets/data)

=== tests/CMakeLists.txt ===
ADD_CUSTOM_TARGET (plugintests
	COMMAND ${CMAKE_CURRENT_BINARY_DIR}/../rkward/rkward --evaluate "source\\(\\\"all_tests.R\\\"\\)"
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== rkward/autotests/CMakeLists.txt ===
include(ECMMarkAsTest)

find_package(Qt5 5.9 QUIET REQUIRED Test)

macro(rkward_executable_tests)
  foreach(_testname ${ARGN})
    add_executable(${_testname} ${_testname}.cpp)

    target_link_libraries(${_testname} PRIVATE rkward_lib Qt5::Test)

    add_test(NAME rkward-${_testname} COMMAND ${_testname})
    ecm_mark_as_test(${_testname})
  endforeach()
endmacro()

rkward_executable_tests(
  core_test
)

=== rkward/dialogs/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}    )

SET(dialogs_STAT_SRCS
   rkloadlibsdialog.cpp
   rkreadlinedialog.cpp
   rkimportdialog.cpp
   rkselectlistdialog.cpp
   rkrecoverdialog.cpp
   rkerrordialog.cpp
   rksavemodifieddialog.cpp
   rksetupwizard.cpp
   )

ADD_DEFINITIONS(-DLIBEXECDIR="${CMAKE_INSTALL_FULL_LIBEXECDIR}")
ADD_LIBRARY(dialogs STATIC ${dialogs_STAT_SRCS})
TARGET_LINK_LIBRARIES(dialogs Qt5::Widgets KF5::Parts KF5::ConfigWidgets KF5::TextEditor)

=== rkward/icons/CMakeLists.txt ===
ADD_SUBDIRECTORY(app-icon)

INSTALL(FILES
	rkward_logo.png
	function.png
	list.png
	matrix.png
	menu.svg
	data-numeric.png
	data-factor.png
	data-logical.png
	window_back.png
	window_forward.png
	run_line.png
	run_selection.png
	run_all.png
	s4_slots.png
	paste_inside_selection.png
	paste_inside_table.png
	DESTINATION ${DATA_INSTALL_DIR}/rkward/icons)

=== rkward/misc/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
    xmlhelper.cpp
    multistringselector.cpp
    rkcommonfunctions.cpp
+   rkcompatibility.cpp
    rkprogresscontrol.cpp
    rksaveobjectchooser.cpp
    rkdummypart.cpp
@@ -27,7 +28,10 @@
    rkaccordiontable.cpp
    rkxmlguipreviewarea.cpp
    rkdialogbuttonbox.cpp
+   rkoutputdirectory.cpp
+   rkstyle.cpp
+   rkparsedversion.cpp
    )
 
 ADD_LIBRARY(misc STATIC ${misc_STAT_SRCS})
-TARGET_LINK_LIBRARIES(misc Qt5::Widgets KF5::WidgetsAddons KF5::KIOWidgets Qt5::Xml KF5::ConfigCore KF5::Parts KF5::WindowSystem KF5::TextEditor)
+TARGET_LINK_LIBRARIES(misc Qt5::Widgets KF5::WidgetsAddons KF5::KIOWidgets Qt5::Xml KF5::ConfigCore KF5::Parts KF5::WindowSystem KF5::TextEditor KF5::Archive)

=== rkward/plugin/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}    )


########### next target ###############

SET(plugin_STAT_SRCS
   rkcomponentmap.cpp
   rkcomponentmeta.cpp
   rkcomponentproperties.cpp
   rkcomponent.cpp
   rkstandardcomponent.cpp
   rkvarselector.cpp
   rkvarslot.cpp
   rkformula.cpp
   rkradio.cpp
   rkcheckbox.cpp
   rkpluginspinbox.cpp
   rkinput.cpp
   rkpluginbrowser.cpp
   rktext.cpp
   rktabpage.cpp
   rkstandardcomponentgui.cpp
   rkdropdown.cpp
   rkcomponentcontext.cpp
   rkpreviewbox.cpp
   rkpluginsaveobject.cpp
   rkabstractoptionselector.cpp
   rkpluginframe.cpp
   rkoptionset.cpp
   rkmatrixinput.cpp
   rkvalueselector.cpp
   )

ADD_LIBRARY(plugin STATIC ${plugin_STAT_SRCS})
TARGET_LINK_LIBRARIES(plugin Qt5::Widgets KF5::TextEditor KF5::WindowSystem)

=== rkward/rbackend/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
 	rbackend_shared_SRCS
 	rkrbackendprotocol_shared.cpp
 	rdata.cpp
+	rktransmitter.cpp
 )
 
 SET (
@@ -23,44 +24,51 @@
 	rkstructuregetter.cpp
 	rkrbackendprotocol_backend.cpp
 	rkreventloop.cpp
+	rkbackendtransmitter.cpp
 )
 
 SET (
 	rbackend_frontend_SRCS
 	rkrinterface.cpp
 	rcommand.cpp
-	rcommandreceiver.cpp
 	rcommandstack.cpp
 	rkrbackendprotocol_frontend.cpp
 	rksessionvars.cpp
+	rkfrontendtransmitter.cpp
 )
 
-SET (
-	rbackend_FRONTEND_SRCS
-	${rbackend_frontend_SRCS}
-	${rbackend_shared_SRCS}
-	rkfrontendtransmitter.cpp
-	rktransmitter.cpp
-)
-ADD_LIBRARY(rbackend STATIC ${rbackend_FRONTEND_SRCS})
+ADD_LIBRARY(rbackend STATIC ${rbackend_frontend_SRCS} ${rbackend_shared_SRCS})
 TARGET_LINK_LIBRARIES(rbackend rkgraphicsdevice.frontend Qt5::Widgets KF5::TextEditor KF5::WindowSystem)
 
-SET (
-	rbackend_BACKEND_SRCS
-	${rbackend_backend_SRCS}
-	${rbackend_shared_SRCS}
-	rkbackendtransmitter.cpp
-	rktransmitter.cpp
-)
-ADD_DEFINITIONS (-DRKWARD_SPLIT_PROCESS)
 ADD_DEFINITIONS (-DRKWARD_BACKEND_PATH="${KDE_INSTALL_FULL_LIBEXECDIR}")
 LINK_DIRECTORIES(${R_SHAREDLIBDIR})
-ADD_EXECUTABLE(rkward.rbackend ${rbackend_BACKEND_SRCS})
+ADD_EXECUTABLE(rkward.rbackend ${rbackend_backend_SRCS} ${rbackend_shared_SRCS})
 ECM_MARK_NONGUI_EXECUTABLE(rkward.rbackend)
 TARGET_LINK_LIBRARIES(rkward.rbackend rkgraphicsdevice.backend ${R_USED_LIBS} ${CMAKE_THREAD_LIBS_INIT} Qt5::Network Qt5::Core KF5::I18n)
+IF(WIN32)
+# 64MB stack size is what R itself is build with on Windows, while by default the stack size would be 1MB
+# Not sure, if 64MB is actually needed, but 1MB does cause trouble e.g. with some shiny apps.
+    IF(MSVC)
+        SET_TARGET_PROPERTIES(rkward.rbackend PROPERTIES LINK_FLAGS /STACK:64000000)
+    ELSE(MSVC)
+        SET_TARGET_PROPERTIES(rkward.rbackend PROPERTIES LINK_FLAGS -Wl,--stack,64000000)
+    ENDIF(MSVC)
+ENDIF(WIN32)
+
 IF(APPLE)
     TARGET_LINK_LIBRARIES(rkward.rbackend "-framework CoreFoundation")
+    ADD_CUSTOM_COMMAND(TARGET rkward.rbackend POST_BUILD
+    COMMAND codesign -d --force --options runtime --verbose=4 -s - --entitlements "${CMAKE_CURRENT_SOURCE_DIR}/rkward.rbackend.entitlements" ${CMAKE_CURRENT_BINARY_DIR}/rkward.rbackend
+    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
+    COMMENT "Adding entitlment for rkward.rbackend to link to external R lib...")
 ENDIF()
+IF(MSVC)
+# When compiling with MSVC, we have to create a .lib file for R.dll, first
+FIND_PACKAGE(Python3 COMPONENTS Interpreter REQUIRED)
+ADD_CUSTOM_TARGET(R_lib COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/GenLibFile.py ${LIBR_SO} ${CMAKE_BINARY_DIR} ${CMAKE_SYSTEM_PROCESSOR}
+                        COMMENT "Generate .lib file for R.dll")
+ADD_DEPENDENCIES(rkward.rbackend R_lib)
+ENDIF(MSVC)
 
 IF(WIN32)
 	# on Widows, we install to the rbackend subdirectory, because 1) LIBEXEC_INSTALL_DIR == BIN_INSTALL_DIR and 2) we don't want the backend to pick up

=== rkward/scriptbackends/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,6 @@
    )
 
 ADD_LIBRARY(scriptbackends STATIC ${scriptbackends_STAT_SRCS})
-TARGET_LINK_LIBRARIES(scriptbackends Qt5::Script Qt5::Widgets Qt5::Xml KF5::WidgetsAddons KF5::I18n)
+TARGET_LINK_LIBRARIES(scriptbackends Qt5::Qml Qt5::Widgets Qt5::Xml KF5::WidgetsAddons KF5::I18n)
 
 INSTALL(FILES common.js rkcomponentscripting.js DESTINATION ${DATA_INSTALL_DIR}/rkward/phpfiles )

=== rkward/settings/CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,7 @@
    rksettingsmoduleconsole.cpp
    rksettingsmodulecommandeditor.cpp
    rksettingsmoduledebug.cpp
+   rkrecenturls.cpp
    )
 
 IF (WIN32 OR USE_BINARY_PACKAGES)

=== rkward/syntax/CMakeLists.txt ===
IF(${KF5_VERSION} VERSION_GREATER "5.27.9")
    SET(SYNTAX_DEST ${DATA_INSTALL_DIR}/org.kde.syntax-highlighting/syntax/)
ELSE(${KF5_VERSION} VERSION_GREATER "5.27.9")
    SET(SYNTAX_DEST ${DATA_INSTALL_DIR}/katepart5/syntax/)
ENDIF(${KF5_VERSION} VERSION_GREATER "5.27.9")

INSTALL(FILES rkward.xml DESTINATION ${SYNTAX_DEST})

=== rkward/windows/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
 	rkdebugmessagewindow.cpp
 	katepluginintegration.cpp
 	rkcodecompletion.cpp
+	rktexthints.cpp
 )
 
 ADD_LIBRARY(windows STATIC ${windows_STAT_SRCS})

=== debian/changelog ===
rkward (0.7.5-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with QtWebEngine. (Closes: #1093381)

 -- Bastian Germann <bage@debian.org>  Sat, 18 Jan 2025 23:47:39 +0100

rkward (0.7.5-3) unstable; urgency=medium

  * Team upload.
  * Backport upstream commit b53d754f18bef786e92f266f576afdbe5fd7d00b, and
    commit ded0472b90c398adc05a7fed1b6446417789ba58 to build with newer versions
    of R; patches upstream_Fix-not-a-string-literal-compile-error.patch, and
    upstream_Fix-compilation.patch. (Closes: #1071360)
  * Bump Standards-Version to 4.7.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Tue, 28 May 2024 07:28:08 +0200

rkward (0.7.5-2) unstable; urgency=medium

  * Team upload.
  * Depend also on the R graphics engine version: (Closes: #1058801)
    - query the r-graphics-engine-N provide from r-base-core
    - add it as dependency via substvars
  * Update standards version to 4.6.2, no changes needed.
  * Drop the breaks/replaces for versions older than what is in Debian Bullseye
    (i.e. current oldstable).

 -- Pino Toscano <pino@debian.org>  Sat, 16 Dec 2023 20:23:16 +0100

rkward (0.7.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * This new version has tests that require a display, so:
    - add the xvfb, and xauth build dependencies
    - run dh_auto_test via xvfb-run
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Sat, 22 Oct 2022 13:06:04 +0200

=== debian/control ===
--- 
+++ 
@@ -19,14 +19,15 @@
                libkf5parts-dev (>= 5.44.0~),
                libkf5texteditor-dev (>= 5.44.0~),
                libkf5xmlgui-dev (>= 5.44.0~),
-               libkf5webkit-dev (>= 5.44.0~),
                libkf5widgetsaddons-dev (>= 5.44.0~),
                libkf5windowsystem-dev (>= 5.44.0~),
-               libqt5webkit5-dev (>= 5.9.0~),
+               qtwebengine5-dev (>= 5.9.0~),
                qtbase5-dev (>= 5.9.0~),
                qtdeclarative5-dev (>= 5.9.0~),
-               r-base-dev
-Standards-Version: 4.6.1
+               r-base-dev,
+               xauth <!nocheck>,
+               xvfb <!nocheck>,
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/rkward
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/rkward.git
 Homepage: https://rkward.kde.org
@@ -38,10 +39,9 @@
          ${misc:Depends},
          ${rvers},
          ${rapivers},
+         ${rgraphicsenginevers},
          ${shlibs:Depends}
 Recommends: r-base-html
-Breaks: rkward-data (<< 0.7.1b-2~)
-Replaces: rkward-data (<< 0.7.1b-2~)
 Description: KDE frontend to the R statistics language
  RKWard aims to become an easy to use, transparent frontend to R,
  a powerful system for statistical computation and graphics.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure '--buildsystem=kf5' -- \
		-DR_EXECUTABLE=/usr/bin/R/ \
		-DCMAKE_SKIP_RPATH=YES

override_dh_auto_test:
	xvfb-run -a --server-args="-screen 0 1024x768x24+32" dh_auto_test

override_dh_gencontrol-arch:
	# We need to know the R version
	dh_gencontrol -a -- \
	  -V'rvers=r-base-core (>= $(shell dpkg-query -W --showformat='$${Version}' r-base-core))' \
	  -V'rapivers=$(shell dpkg-query -W --showformat='$${Provides}' r-base-core | grep -o 'r-api[^, ]*')' \
	  -V'rgraphicsenginevers=$(shell dpkg-query -W --showformat='$${Provides}' r-base-core | grep -o 'r-graphics-engine[^, ]*')'
